<?php

namespace App\Policies;

use App\Domain\Points\Models\Point;
use App\Models\User;
use Illuminate\Auth\Access\HandlesAuthorization;

class PointPolicy
{
    use HandlesAuthorization;

    public function before(User $user)
    {
        if ($user->hasRole('administrators')) {
            return true;
        }
    }

    /**
     * Determine whether the user can view any models.
     *
     * @param  \App\Models\User  $user
     * @return mixed
     */
    public function viewAny(User $user)
    {

        if ($user->hasRole('finance')) {
            return true;
        }
    }

    /**
     * Determine whether the user can view the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Models\Point  $point
     * @return mixed
     */
    public function view(User $user, Point $point)
    {
        if ($user->hasRole('finance')) {
            return true;
        }
    }

    /**
     * Determine whether the user can create models.
     *
     * @param  \App\Models\User  $user
     * @return mixed
     */
    public function create(User $user)
    {
        if ($user->hasRole('finance')) {
            return true;
        }
    }

    /**
     * Determine whether the user can update the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Models\Point  $point
     * @return mixed
     */
    public function update(User $user, Point $point)
    {
        //
    }

    /**
     * Determine whether the user can delete the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Models\Point  $point
     * @return mixed
     */
    public function delete(User $user, Point $point)
    {
        //
    }

    /**
     * Determine whether the user can restore the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Models\Point  $point
     * @return mixed
     */
    public function restore(User $user, Point $point)
    {
        //
    }

    /**
     * Determine whether the user can permanently delete the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Models\Point  $point
     * @return mixed
     */
    public function forceDelete(User $user, Point $point)
    {
        //
    }
}
